unit GUI;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, klassen;

type
  TForm1 = class(TForm)
    ed_marke: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ed_typ: TEdit;
    Label3: TLabel;
    ed_bj: TEdit;
    Label4: TLabel;
    ed_km: TEdit;
    Label5: TLabel;
    ed_preis: TEdit;
    lb: TListBox;
    bt_einlesen: TButton;
    bt_ausgabe: TButton;
    bt_save: TButton;
    bt_load: TButton;
    procedure bt_einlesenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bt_ausgabeClick(Sender: TObject);
    procedure bt_saveClick(Sender: TObject);
    procedure bt_loadClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  autos:array of tauto;


implementation

{$R *.dfm}

procedure TForm1.bt_ausgabeClick(Sender: TObject);
var i:integer;
begin
 lb.clear;
 for i:=0 to high (autos) do
   begin
     lb.items.add(inttostr(i));
     lb.items.add(autos[i].get_marke);
     lb.items.add(autos[i].get_typ);
     lb.items.add(inttostr(autos[i].get_baujahr));
     lb.items.add(inttostr(autos[i].get_km));
     lb.items.add(floattostr(autos[i].get_preis));
     lb.items.add('-----------------------------');
   end;
 lb.items.add('Gesamtzahl: '+inttostr(i));
end;

procedure TForm1.bt_einlesenClick(Sender: TObject);
 var n:integer;
begin
 n:=length(autos);
 setlength(autos,n+1);
 autos[n]:=Tauto.Create;
 autos[n].set_marke(ed_marke.text);
 autos[n].set_typ(ed_typ.text);
 autos[n].set_baujahr(strtoint(ed_bj.text));
 autos[n].set_km(strtoint(ed_km.text));
 autos[n].set_preis(strtofloat(ed_preis.text));
 ed_marke.clear;
 ed_typ.clear;
 ed_bj.clear;
 ed_km.clear;
 ed_preis.clear;
 ed_marke.setfocus;
end;

procedure TForm1.bt_loadClick(Sender: TObject);
var sd:Topendialog;
      i:integer;
      fehler:boolean;
begin
 setlength(a,0);
 fehler:=true;
 sd:=topendialog.create(form1);
 sd.filter:='Auto-Dateien|*.aut';
 if sd.execute then
  begin
    assignfile(f,sd.filename);
    try
      reset(f);
      while not eof(f) do
       begin
         i:=length(a);
         setlength(a,i+1);
         read(f,a[i]);
       end;
      fehler:=false;
    finally
      closefile(f);
    end;
  end;
  setlength(autos,length(a));
  for i:=0 to high(a) do
    begin
      autos[i]:=Tauto.Create;
      autos[i].set_all(a[i]);
    end;
 if not fehler then application.messagebox('Geladen!','Autos laden',0) else
                    application.messagebox('Fehler beim Laden!','Autos laden',0);
 sd.free;
end;

procedure TForm1.bt_saveClick(Sender: TObject);
 var sd:Tsavedialog;
      i:integer;
      fehler:boolean;
begin
  // Daten in record
 setlength(a,length(autos));
 for i:=0 to high(a) do
     a[i]:=autos[i].get_all;
 fehler:=true;
 sd:=tsavedialog.create(form1);
 sd.filter:='Auto-Dateien|*.aut';
 sd.defaultext:='aut';
 if sd.execute then
  begin
    assignfile(f,sd.filename);
    try
      rewrite(f);
      for i:=0 to high(a)do
       begin
         write(f,a[i]);
       end;
      fehler:=false;
    finally
      closefile(f);
    end;
  end;
 if not fehler then application.messagebox('Gespeichert!','Autos speichern',0) else
                     application.messagebox('Fehler beim Speichern!','Autos speichern',0);
sd.free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 setlength(autos,0);
end;

end.
